"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireDefault(require("react"));

var _PropTypes = require("./PropTypes");

var _Handle = _interopRequireDefault(require("./Handle"));

var _Context = _interopRequireDefault(require("./Context"));

var _Request = _interopRequireDefault(require("./Request"));

var _view = _interopRequireDefault(require("./view"));

var _Utils = require("./Utils");

var RUIG =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2.default)(RUIG, _React$Component);

  function RUIG(_ref) {
    var _this;

    var initialState = _ref.initialState,
        ssrSupport = _ref.ssrSupport;
    (0, _classCallCheck2.default)(this, RUIG);
    _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(RUIG).call(this));
    _this.fileInput = _react.default.createRef();
    _this.setSort = _this.setSort.bind((0, _assertThisInitialized2.default)(_this));
    _this.uploadFiles = _this.uploadFiles.bind((0, _assertThisInitialized2.default)(_this));
    _this.openDialogue = _this.openDialogue.bind((0, _assertThisInitialized2.default)(_this));
    _this.onProgress = _this.onProgress.bind((0, _assertThisInitialized2.default)(_this));
    _this.onSuccess = _this.onSuccess.bind((0, _assertThisInitialized2.default)(_this));
    _this.onWarning = _this.onWarning.bind((0, _assertThisInitialized2.default)(_this));
    _this.onError = _this.onError.bind((0, _assertThisInitialized2.default)(_this));
    _this.requests = [];
    _this.increment = 0;
    _this.state = {
      images: initialState.reverse().map(function (item) {
        return _this.create((0, _objectSpread2.default)({
          done: true
        }, item));
      }).reverse(),
      renderComponent: !ssrSupport
    };
    return _this;
  }

  (0, _createClass2.default)(RUIG, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$props = this.props,
          ssrSupport = _this$props.ssrSupport,
          onChange = _this$props.onChange; // start application send initialState images

      onChange(this.state.images); // ssrSupport

      if (ssrSupport) {
        this.setState({
          renderComponent: true
        });
      }
    }
  }, {
    key: "create",
    value: function create(item) {
      var _this2 = this;

      var uid = "ruig-".concat(Date.now(), "-").concat(this.increment++);
      return (0, _objectSpread2.default)({
        uid: uid,
        done: false,
        error: false,
        progress: 0,
        refresh: null,
        abort: function abort() {},
        remove: function remove() {
          return _this2.remove(uid);
        },
        click: function click() {
          return _this2.onClick(uid);
        },
        select: function select() {
          return _this2.onSelected(uid);
        }
      }, item);
    }
  }, {
    key: "refresh",
    value: function refresh(uid) {
      var _this3 = this;

      this.setImage(uid, {
        error: false,
        progress: 0
      }, function (image) {
        return _this3.upload(image);
      });
    }
  }, {
    key: "remove",
    value: function () {
      var _remove = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee(uid) {
        var _this4 = this;

        var images, deletedImage, key, image;
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                images = this.state.images;
                _context.t0 = _regenerator.default.keys(images);

              case 2:
                if ((_context.t1 = _context.t0()).done) {
                  _context.next = 14;
                  break;
                }

                key = _context.t1.value;
                image = images[key];

                if (!(image.uid === uid)) {
                  _context.next = 12;
                  break;
                }

                _context.next = 8;
                return this.props.onConfirmDelete(image, images);

              case 8:
                if (!_context.sent) {
                  _context.next = 12;
                  break;
                }

                if (typeof image.abort === 'function') {
                  image.abort();
                }

                deletedImage = image;
                images.splice(key, 1);

              case 12:
                _context.next = 2;
                break;

              case 14:
                this.setState({
                  images: images
                }, function () {
                  _this4.props.onChange(_this4.state.images);

                  if (deletedImage) {
                    _this4.props.onDeleted(deletedImage, _this4.state.images);
                  }
                });

              case 15:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function remove(_x) {
        return _remove.apply(this, arguments);
      }

      return remove;
    }()
  }, {
    key: "onProgress",
    value: function onProgress(uid, percentage) {
      this.setImage(uid, {
        progress: isNaN(percentage) ? 0 : percentage
      });
    }
  }, {
    key: "onSuccess",
    value: function onSuccess(uid, response) {
      var _this5 = this;

      var source = this.props.source;
      source = typeof source === 'function' ? source(response) : response.source;
      this.setImage(uid, {
        source: source,
        done: true,
        error: false,
        progress: 100
      }, function () {
        return _this5.props.onSuccess(_this5.state.images);
      });
    }
  }, {
    key: "onError",
    value: function onError(uid, _ref2) {
      var _this6 = this;

      var status = _ref2.status,
          response = _ref2.response;
      this.setImage(uid, {
        status: status,
        error: true,
        refresh: function refresh() {
          return _this6.refresh(uid);
        }
      }, function (image) {
        _this6.props.onError({
          status: status,
          response: response,
          image: image
        });
      });
    }
  }, {
    key: "onClick",
    value: function onClick(uid) {
      this.props.onClick(this.state.images.find(function (image) {
        return image.uid === uid;
      }));
    }
  }, {
    key: "onWarning",
    value: function onWarning(key, rules) {
      this.props.onWarning(key, rules);
    }
  }, {
    key: "setImage",
    value: function setImage(uid, append, finish) {
      var _this7 = this;

      var image,
          images = this.state.images;
      images = images.map(function (item) {
        if (item.uid === uid) {
          return image = (0, _objectSpread2.default)({}, item, append);
        }

        return item;
      });
      this.setState({
        images: images
      }, function () {
        if (finish) finish(image);

        _this7.props.onChange(images);
      });
    }
  }, {
    key: "onSelected",
    value: function onSelected(uid) {
      var _this8 = this;

      this.setState({
        images: this.state.images.map(function (item) {
          return Object.assign({}, item, {
            selected: item.uid === uid
          });
        })
      }, function () {
        return _this8.props.onChange(_this8.state.images);
      });
    }
  }, {
    key: "openDialogue",
    value: function openDialogue() {
      this.fileInput.current.click();
    }
  }, {
    key: "uploadFiles",
    value: function () {
      var _uploadFiles = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee2(files) {
        var _this9 = this;

        var images, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, file, data, image;

        return _regenerator.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                images = [];
                _iteratorNormalCompletion = true;
                _didIteratorError = false;
                _iteratorError = undefined;
                _context2.prev = 4;
                _iterator = files[Symbol.iterator]();

              case 6:
                if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                  _context2.next = 21;
                  break;
                }

                file = _step.value;
                _context2.prev = 8;
                _context2.next = 11;
                return this.checkFileAndBase64(file, images);

              case 11:
                data = _context2.sent;
                image = this.create({
                  data: data,
                  file: file,
                  source: data,
                  name: file.name,
                  size: (0, _Utils.bytesToSize)(file.size)
                });
                images.push(image);
                _context2.next = 18;
                break;

              case 16:
                _context2.prev = 16;
                _context2.t0 = _context2["catch"](8);

              case 18:
                _iteratorNormalCompletion = true;
                _context2.next = 6;
                break;

              case 21:
                _context2.next = 27;
                break;

              case 23:
                _context2.prev = 23;
                _context2.t1 = _context2["catch"](4);
                _didIteratorError = true;
                _iteratorError = _context2.t1;

              case 27:
                _context2.prev = 27;
                _context2.prev = 28;

                if (!_iteratorNormalCompletion && _iterator.return != null) {
                  _iterator.return();
                }

              case 30:
                _context2.prev = 30;

                if (!_didIteratorError) {
                  _context2.next = 33;
                  break;
                }

                throw _iteratorError;

              case 33:
                return _context2.finish(30);

              case 34:
                return _context2.finish(27);

              case 35:
                this.setState({
                  images: images.concat(this.state.images)
                }, function () {
                  images.forEach(function (image) {
                    return _this9.upload(image);
                  });

                  _this9.props.onChange(_this9.state.images);
                });

              case 36:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this, [[4, 23, 27, 35], [8, 16], [28,, 30, 34]]);
      }));

      function uploadFiles(_x2) {
        return _uploadFiles.apply(this, arguments);
      }

      return uploadFiles;
    }()
  }, {
    key: "checkFileAndBase64",
    value: function () {
      var _checkFileAndBase = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee3(file, images) {
        var _this10 = this;

        var _this$props2, rules, accept, warning, base64, size, limit, width, height, image;

        return _regenerator.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _this$props2 = this.props, rules = _this$props2.rules, accept = _this$props2.accept;
                images = images.concat(this.state.images);
                /*
                 * stop and send message
                 *
                */

                warning = function warning(key) {
                  _this10.onWarning(key, (0, _objectSpread2.default)({}, rules, {
                    accept: accept,
                    file: file
                  }));

                  throw new Error();
                };

                if (!(0, _Utils.isAccepted)(file.type, accept.map(function (type) {
                  return "image/".concat(type);
                }))) {
                  warning('accept');
                }

                _context3.next = 6;
                return (0, _Utils.getBase64)(file);

              case 6:
                base64 = _context3.sent;

                if (!(rules !== null)) {
                  _context3.next = 16;
                  break;
                }

                size = rules.size, limit = rules.limit, width = rules.width, height = rules.height;
                /**
                 * limit
                 * 
                */

                if (limit && images.length >= limit) {
                  warning('limit');
                }
                /**
                 * size
                 * 
                */


                if (size * 1024 < file.size) {
                  warning('size');
                }
                /**
                 * dimensions
                 * 
                */


                _context3.next = 13;
                return (0, _Utils.getImageDimensions)(base64);

              case 13:
                image = _context3.sent;

                if (width) {
                  if (image.width < width.min) {
                    warning('minWidth');
                  } else if (image.width > width.max) {
                    warning('maxWidth');
                  }
                }

                if (height) {
                  if (image.height < height.min) {
                    warning('minHeight');
                  } else if (image.height > height.max) {
                    warning('maxHeight');
                  }
                }

              case 16:
                return _context3.abrupt("return", base64);

              case 17:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function checkFileAndBase64(_x3, _x4) {
        return _checkFileAndBase.apply(this, arguments);
      }

      return checkFileAndBase64;
    }()
  }, {
    key: "upload",
    value: function upload(_ref3) {
      var uid = _ref3.uid,
          file = _ref3.file,
          data = _ref3.data;
      var _this$props3 = this.props,
          send = _this$props3.send,
          action = _this$props3.action,
          headers = _this$props3.headers,
          customRequest = _this$props3.customRequest;
      var request = customRequest || _Request.default;

      var _request = request({
        uid: uid,
        file: file,
        data: data,
        send: send,
        action: action,
        headers: headers,
        onError: this.onError,
        onSuccess: this.onSuccess,
        onProgress: this.onProgress
      }),
          abort = _request.abort;

      this.setImage(uid, {
        abort: abort
      });
    }
  }, {
    key: "setSort",
    value: function setSort(images) {
      var _this11 = this;

      this.setState({
        images: images
      }, function () {
        return _this11.props.onChange(images);
      });
    }
  }, {
    key: "showChildren",
    value: function showChildren(options) {
      var _this$props4 = this.props,
          type = _this$props4.type,
          sorting = _this$props4.sorting,
          children = _this$props4.children,
          images = this.state.images;

      switch ((0, _typeof2.default)(children)) {
        case 'object':
          return children;

        case 'function':
          return children(images, options);

        default:
          return (0, _view.default)({
            type: type,
            sorting: sorting
          }, images);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this12 = this;

      // states
      var _this$state = this.state,
          images = _this$state.images,
          renderComponent = _this$state.renderComponent; // props

      var _this$props5 = this.props,
          className = _this$props5.className,
          style = _this$props5.style,
          accept = _this$props5.accept,
          header = _this$props5.header,
          footer = _this$props5.footer;
      var contextValue = {
        images: images,
        accept: accept,
        setSort: this.setSort,
        uploadFiles: this.uploadFiles,
        openDialogue: this.openDialogue
      },
          options = contextValue; // hide server side rendering

      if (!renderComponent) {
        return null;
      }

      return _react.default.createElement(_Context.default.Provider, {
        value: contextValue
      }, _react.default.createElement("div", {
        className: "ruig ".concat(className),
        style: style
      }, header && (typeof header === 'function' ? header(options) : (0, _Handle.default)(options)), this.showChildren(options), footer && (typeof footer === 'function' ? footer(options) : (0, _Handle.default)(options)), _react.default.createElement("input", {
        multiple: true,
        type: "file",
        ref: this.fileInput,
        className: "ruig-file-input",
        accept: accept.map(function (type) {
          return "image/".concat(type);
        }),
        onChange: function onChange(event) {
          return _this12.uploadFiles(event.target.files);
        }
      })));
    }
  }]);
  return RUIG;
}(_react.default.Component);

RUIG.propTypes = _PropTypes.propTypes;
RUIG.defaultProps = _PropTypes.defaultProps;
var _default = RUIG;
exports.default = _default;